import { Component } from '@angular/core';
import { ActionSheetController } from 'ionic-angular';
@Component({
	selector: 'wx',
	templateUrl:'wx.html'
})
export class wxShare {
	
	constructor(
		public actionSheetCtrl?: ActionSheetController,
	) {
		
	}
	shareWx(sharetitle,sharecontent,m:number,http:any){
		let wechat = (<any>window).Wechat;
	    wechat.isInstalled(function (installed){
	      if(!installed){
	         alert('您没有安装微信！');
	        return ;
	      }
	    }, function (reason) {
	         alert("Failed: " + reason);
	    });
	    wechat.share({
	    message: {
	        title:sharetitle,
	        description:sharecontent,
	        thumb:'http://test.saclass.com/share1to1/img/logo.png',
	        media: {
	            type: wechat.Type.LINK,
	            webpageUrl: http
	        }
	    },
	        scene: m==1 ? 1 : 0  
	    }, function () {
			console.log('分享成功');
	    }, function (reason){
//	        alert("分享失败原因: " + reason);
	    });
	}
	//0朋友,1朋友圈
	shareWxSession(sharetitle:string,sharecontent:string,m:number,http:any){
		let actionSheet = this.actionSheetCtrl.create({
			cssClass:'messageShare',
			buttons: [
		       	{
		         	text: '微信好友',
		         	cssClass:'friend',
		         	handler: () => {
		           		this.shareWx(sharetitle,sharecontent,0,http);
		         	}
		       	},
		       	{
		         	text: '朋友圈',
		         	cssClass:'friendCircle',
		         	handler: () => {
		           		this.shareWx(sharetitle,sharecontent,1,http);
		         	}
		       	}
		    ]
		})
		actionSheet.present();
	}
}